---  arm/arm/pmap.c.orig
+++  arm/arm/pmap.c
@@ -2416,6 +3176,7 @@
 	kernel_pmap = &kernel_pmap_store;
 	kernel_pmap->pm_l1 = l1;
 	kernel_l1pa = l1pt->pv_pa;
+	mtx_init(&l1->l1_mtx, "L1 mtx", NULL, MTX_DEF | MTX_RECURSE);
 	
 	/*
 	 * Scan the L1 translation table created by initarm() and create
@@ -2568,9 +3329,6 @@
 {
 	struct pcb *pcb;
 	
-	pmap_idcache_wbinv_all(pmap);
-	pmap_tlb_flushID(pmap);
-	cpu_cpwait();
 	if (vector_page < KERNBASE) {
 		struct pcb *curpcb = PCPU_GET(curpcb);
 		pcb = thread0.td_pcb;
@@ -2776,22 +3534,82 @@
 {
 	struct pv_entry *pv, *npv;
 	struct l2_bucket *l2b = NULL;
+	pt_entry_t *pt;
+	pd_entry_t *pd;
 	vm_page_t m;
-	pt_entry_t *pt;
-	
+	int i;
+
 	vm_page_lock_queues();
 	PMAP_LOCK(pmap);
 	for (pv = TAILQ_FIRST(&pmap->pm_pvlist); pv; pv = npv) {
-		if (pv->pv_flags & PVF_WIRED) {
+		if (pv->pv_flags & PVF_WIRED) {                  
 			/* The page is wired, cannot remove it now. */
 			npv = TAILQ_NEXT(pv, pv_plist);
 			continue;
 		}
+			    
+		PMAP_LOCK_L1(pmap);
+		pmap_fixup_l1_entry(pmap, pv->pv_va);
+		pd = &pmap->pm_l1->l1_kva[L1_IDX(pv->pv_va)];
+		if (l1pte_section_p(*pd)) {
+			struct l1_ttable *l1;
+
+			for (i = 0; i < 0x100; i++) {
+				m = PHYS_TO_VM_PAGE(
+				    (*pd & L1_S_ADDR_MASK) +
+				    i * PAGE_SIZE);
+				if (TAILQ_EMPTY(&m->md.pv_list))
+					vm_page_flag_clear(m,
+					    PG_WRITEABLE);
+			}
+			*pd = 0;
+			npv = TAILQ_NEXT(pv, pv_plist);
+			pmap_nuke_pv(m, pmap, pv);
+			if (TAILQ_EMPTY(&m->md.pv_list))
+				vm_page_flag_clear(m, PG_WRITEABLE);
+			pmap_free_pv_entry(pv);
+
+			if (pmap == pmap_kernel()) {
+				SLIST_FOREACH(l1, &l1_list,
+				    l1_link) {
+					l1->l1_kva[
+					    L1_IDX(pv->pv_va &
+						L1_S_ADDR_MASK)] = 0;
+					PTE_SYNC(
+					    &l1->l1_kva[L1_IDX(
+					    pv->pv_va &
+					    L1_S_ADDR_MASK)]);
+				}
+			}
+			PMAP_UNLOCK_L1(pmap);
+			continue;
+		}
+		PMAP_UNLOCK_L1(pmap);
 		pmap->pm_stats.resident_count--;
 		l2b = pmap_get_l2_bucket(pmap, pv->pv_va);
 		KASSERT(l2b != NULL, ("No L2 bucket in pmap_remove_pages"));
 		pt = &l2b->l2b_kva[l2pte_index(pv->pv_va)];
-		m = PHYS_TO_VM_PAGE(*pt & L2_ADDR_MASK);
+		if ((*pt & L2_TYPE_MASK) == L2_TYPE_L) {
+			pt = &l2b->l2b_kva[l2pte_index(pv->pv_va &
+			    L2_L_FRAME)];
+			for (int i = 0; i < 0x10; i++) {
+				m = PHYS_TO_VM_PAGE((pt[i] &
+				    L2_L_FRAME) + i * PAGE_SIZE);
+				if (TAILQ_EMPTY(&m->md.pv_list))
+					vm_page_flag_clear(m,
+					    PG_WRITEABLE);
+				pt[i] = 0;
+			}
+			pmap_free_l2_bucket(pmap, l2b, 0x10);
+			npv = TAILQ_NEXT(pv, pv_plist);
+			pmap_nuke_pv(m, pmap, pv);
+			if (TAILQ_EMPTY(&m->md.pv_list))
+				vm_page_flag_clear(m, PG_WRITEABLE);
+			pmap_free_pv_entry(pv);
+
+			continue;
+		}
+		m = pv->pv_page;
 #ifdef ARM_USE_SMALL_ALLOC
 		KASSERT((vm_offset_t)m >= alloc_firstaddr, ("Trying to access non-existent page va %x pte %x", pv->pv_va, *pt));
 #else
@@ -3052,7 +3870,6 @@
 	}
 }
 
-
 /*
  * pmap_object_init_pt preloads the ptes for a given object
  * into the specified pmap.  This eliminates the blast of soft
@@ -3083,7 +3900,8 @@
 
 	if (!pmap_get_pde_pte(pmap, addr, &pde, &pte))
 		return (FALSE);
-	KASSERT(pte != NULL, ("Valid mapping but no pte ?"));
+	if (!pte)
+		return (FALSE);
 	if (*pte == 0)
 		return (TRUE);
 	return (FALSE);
@@ -3116,14 +3934,17 @@
 		return (FALSE);
 
 	l1idx = L1_IDX(va);
+	PMAP_LOCK_L1(pm);
+	pmap_fixup_l1_entry(pm, va);
 	*pdp = pl1pd = &pm->pm_l1->l1_kva[l1idx];
 	l1pd = *pl1pd;
 
 	if (l1pte_section_p(l1pd)) {
+		PMAP_UNLOCK_L1(pm);
 		*ptp = NULL;
 		return (TRUE);
 	}
-
+	PMAP_UNLOCK_L1(pm);
 	if (pm->pm_l2 == NULL)
 		return (FALSE);
 
@@ -3154,6 +3975,7 @@
 pmap_remove_all(vm_page_t m)
 {
 	pv_entry_t pv;
+	pd_entry_t *pd;
 	pt_entry_t *ptep, pte;
 	struct l2_bucket *l2b;
 	boolean_t flush = FALSE;
@@ -3174,14 +3996,33 @@
 		return;
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
 	curpm = vmspace_pmap(curproc->p_vmspace);
+redo:
 	while ((pv = TAILQ_FIRST(&m->md.pv_list)) != NULL) {
 		if (flush == FALSE && (pv->pv_pmap == curpm ||
 		    pv->pv_pmap == pmap_kernel()))
 			flush = TRUE;
 		PMAP_LOCK(pv->pv_pmap);
+		PMAP_LOCK_L1(pv->pv_pmap);
+		pmap_fixup_l1_entry(pv->pv_pmap, pv->pv_va);
+		pd = &pv->pv_pmap->pm_l1->l1_kva[L1_IDX(pv->pv_va)];
+		/* Demotion mess up with the PV list. */
+		if (l1pte_section_p(*pd)) {
+			pmap_t pm = pv->pv_pmap;
+			pmap_demote(pv->pv_pmap, pv->pv_va);
+			PMAP_UNLOCK_L1(pm);
+			PMAP_UNLOCK(pm);
+			goto redo;
+		}
+		PMAP_UNLOCK_L1(pv->pv_pmap);
 		l2b = pmap_get_l2_bucket(pv->pv_pmap, pv->pv_va);
+		
 		KASSERT(l2b != NULL, ("No l2 bucket"));
 		ptep = &l2b->l2b_kva[l2pte_index(pv->pv_va)];
+		if ((*ptep & L2_TYPE_MASK) == L2_TYPE_L) {
+			pmap_demote(pv->pv_pmap, pv->pv_va);
+			PMAP_UNLOCK(pv->pv_pmap);
+			goto redo;
+		}
 		pte = *ptep;
 		*ptep = 0;
 		PTE_SYNC_CURRENT(pv->pv_pmap, ptep);
@@ -3217,6 +4058,9 @@
 	vm_offset_t next_bucket;
 	u_int flags;
 	int flush;
+	int demoted = 0;
+	int i;
+	pd_entry_t *pd;
 
 	if ((prot & VM_PROT_READ) == 0) {
 		pmap_remove(pm, sva, eva);
@@ -3244,10 +4088,53 @@
 	flags = 0;
 
 	while (sva < eva) {
+		demoted = 0;
 		next_bucket = L2_NEXT_BUCKET(sva);
 		if (next_bucket > eva)
 			next_bucket = eva;
+		PMAP_LOCK_L1(pm);
+		pmap_fixup_l1_entry(pm, sva);
+
+		if (l1pte_section_p(pm->pm_l1->l1_kva[L1_IDX(sva)])) {
+			if ((sva & L1_S_OFFSET) == 0 &&
+			    sva + L1_S_SIZE < eva) {
+				struct l1_ttable *l1;
 
+				/* Change the whole 1MB superpage. */
+				pd = &pm->pm_l1->l1_kva[L1_IDX(sva)];
+				if (*pd & L1_S_PROT_W) {
+					*pd &= ~L1_S_PROT_W;
+					PTE_SYNC(*pd);
+					flush++;
+					flags |= pmap_clearbit_pv_range(pm, sva,
+					    sva + L1_S_SIZE, PVF_WRITE);
+					for (i = 0; i < 0x100; i++) {
+						vm_page_t m =
+						    PHYS_TO_VM_PAGE(
+							(*pd & L1_S_FRAME) +
+							i * PAGE_SIZE);
+						pmap_vac_me_harder(m, pm,
+						    sva + i * PAGE_SIZE);
+						vm_page_dirty(m);
+					}
+				}
+				if (pm == pmap_kernel()) {
+					SLIST_FOREACH(l1, &l1_list, l1_link) {
+						l1->l1_kva[L1_IDX(sva)] =
+						    *pd;
+						PTE_SYNC(&l1->l1_kva[L1_IDX(sva)]);
+					}
+				}
+				PMAP_UNLOCK_L1(pm);
+				sva += L1_S_SIZE;
+				continue;
+			}
+			pmap_demote(pm, sva);
+			flush = 1;
+			l2b = pmap_get_l2_bucket(pm, sva);
+			demoted = 1;
+		}
+		PMAP_UNLOCK_L1(pm);
 		l2b = pmap_get_l2_bucket(pm, sva);
 		if (l2b == NULL) {
 			sva = next_bucket;
@@ -3257,6 +4144,37 @@
 		ptep = &l2b->l2b_kva[l2pte_index(sva)];
 
 		while (sva < next_bucket) {
+			demoted = 0;
+			if ((*ptep & L2_TYPE_MASK) == L2_TYPE_L) {
+				if ((sva & L2_L_OFFSET) == 0 &&
+				    sva + L2_L_SIZE < eva) {
+					if (*ptep & L2_L_PROT_W) {
+						flags |= pmap_clearbit_pv_range(
+						    pm, sva, 
+						    sva + L2_L_SIZE, PVF_WRITE);
+						for (i = 0; i < 0x10; i++) {
+							vm_page_t m;
+
+							m = PHYS_TO_VM_PAGE(
+							    (ptep[i] & 
+							    L2_L_FRAME) + 
+							    i * PAGE_SIZE);
+							ptep[i] &= ~L2_L_PROT_W;
+							PTE_SYNC(&ptep[i]);
+							pmap_vac_me_harder(m,
+							    pm, sva + 
+							    i * PAGE_SIZE);
+							vm_page_dirty(m);
+						}
+						flush++;
+					}
+					sva += L2_L_SIZE;
+					continue;
+				} else {
+					pmap_demote(pm, sva);
+					demoted = 1;
+				}
+			}
 			if ((pte = *ptep) != 0 && (pte & L2_S_PROT_W) != 0) {
 				struct vm_page *pg;
 				u_int f;
@@ -3285,6 +4203,12 @@
 					pmap_tlb_flushD_SE(pm, sva);
 			}
 
+			if (demoted) {
+				PMAP_LOCK_L1(pm);
+				pmap_promote_small(pm, l2b, sva);
+				pmap_promote_large(pm, sva);
+				PMAP_UNLOCK_L1(pm);
+			}
 			sva += PAGE_SIZE;
 			ptep++;
 		}
@@ -3303,7 +4227,6 @@
  	PMAP_UNLOCK(pm);
 }
 
-
 /*
  *	Insert the given physical page (p) at
  *	the specified virtual address (v) in the
@@ -3318,8 +4241,8 @@
  */
 
 void
-pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
-    boolean_t wired)
+pmap_enter(pmap_t pmap, vm_offset_t va, vm_prot_t fault_type, vm_page_t m, 
+    vm_prot_t prot, boolean_t wired)
 {
 
 	vm_page_lock_queues();
@@ -3337,15 +4260,56 @@
     boolean_t wired, int flags)
 {
 	struct l2_bucket *l2b = NULL;
-	struct vm_page *opg;
+	struct vm_page *opg = NULL;
 	struct pv_entry *pve = NULL;
 	pt_entry_t *ptep, npte, opte;
+	pd_entry_t l1pd;
 	u_int nflags;
 	u_int oflags;
 	vm_paddr_t pa;
 
 	PMAP_ASSERT_LOCKED(pmap);
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
+	PMAP_LOCK_L1(pmap);
+	pmap_fixup_l1_entry(pmap, va);
+	l1pd = pmap->pm_l1->l1_kva[L1_IDX(va)];
+	if (l1pte_section_p(l1pd) &&
+	    ((l1pd & L1_S_FRAME) != (VM_PAGE_TO_PHYS(m) & L1_S_FRAME) ||
+	     (((VM_PAGE_TO_PHYS(m) & L2_S_FRAME) & L2_S_OFFSET) !=
+	      (va & L2_S_OFFSET)) ||
+	     ((l1pd & L1_S_PROT_U) != 0) != (pmap != pmap_kernel() && va !=
+		vector_page) || ((l1pd & L1_S_PROT_W) != 0) !=
+	     ((prot & VM_PROT_WRITE) != 0))) {
+		/* There's already a superpage at this address, demote. */
+		pmap_demote(pmap, va);
+		pmap_tlb_flushID_SE(pmap, va & L1_S_ADDR_MASK);
+	} else if (l1pte_section_p(l1pd)) {
+		opg = m;
+		l2b = NULL;
+	}
+	PMAP_UNLOCK_L1(pmap);
+	
+	if (opg == NULL) {
+		if (pmap == pmap_kernel()) {
+			l2b = pmap_get_l2_bucket(pmap, va);
+			if (l2b == NULL)
+				l2b = pmap_grow_l2_bucket(pmap, va);
+		} else {
+do_l2b_alloc:
+			l2b = pmap_alloc_l2_bucket(pmap, va, M_NOWAIT);
+			if (l2b == NULL) {
+				if (flags & M_WAITOK) {
+					PMAP_UNLOCK(pmap);
+					vm_page_unlock_queues();
+					VM_WAIT;
+					vm_page_lock_queues();
+					PMAP_LOCK(pmap);
+					goto do_l2b_alloc;
+				}
+				return;
+			}
+		}
+	}
 	if (va == vector_page) {
 		pa = systempage.pv_pa;
 		m = NULL;
@@ -3361,43 +4325,39 @@
 	PDEBUG(1, printf("pmap_enter: pmap = %08x, va = %08x, m = %08x, prot = %x, "
 	    "wired = %x\n", (uint32_t) pmap, va, (uint32_t) m, prot, wired));
 	    
-	if (pmap == pmap_kernel()) {
-		l2b = pmap_get_l2_bucket(pmap, va);
-		if (l2b == NULL)
-			l2b = pmap_grow_l2_bucket(pmap, va);
+	if (l2b != NULL) {
+		ptep = &l2b->l2b_kva[l2pte_index(va)];
+		opte = *ptep;
+		npte = pa; 
+		oflags = 0;
 	} else {
-do_l2b_alloc:
-		l2b = pmap_alloc_l2_bucket(pmap, va);
-		if (l2b == NULL) {
-			if (flags & M_WAITOK) {
-				PMAP_UNLOCK(pmap);
-				vm_page_unlock_queues();
-				VM_WAIT;
-				vm_page_lock_queues();
-				PMAP_LOCK(pmap);
-				goto do_l2b_alloc;
+		npte = oflags = opte = 0;
+		ptep = NULL;
+	}
+	if (opte) {
+		if ((opte & L2_TYPE_MASK) == L2_TYPE_L) {
+			if (((opte & L2_L_FRAME) | (va & L2_L_OFFSET)) ==
+			    VM_PAGE_TO_PHYS(m) &&
+			    (((opte & L2_L_PROT_W) != 0) ==
+			    (prot & VM_PROT_WRITE) != 0) &&
+			    (((opte & L2_L_PROT_U) == 0) ==
+			     (pmap == pmap_kernel() || va == vector_page)))
+				opg = m;
+			else {
+				pmap_demote(pmap, va);
+				opte = *ptep;
 			}
-			return;
 		}
-	}
-
-	ptep = &l2b->l2b_kva[l2pte_index(va)];
-		    
-	opte = *ptep;
-	npte = pa;
-	oflags = 0;
-	if (opte) {
 		/*
 		 * There is already a mapping at this address.
 		 * If the physical address is different, lookup the
 		 * vm_page.
 		 */
-		if (l2pte_pa(opte) != pa)
+		if (!opg && l2pte_pa(opte) != pa)
 			opg = PHYS_TO_VM_PAGE(l2pte_pa(opte));
-		else
+		else if (!opg)
 			opg = m;
-	} else
-		opg = NULL;
+	}
 
 	if ((prot & (VM_PROT_ALL)) ||
 	    (!m || m->md.pvh_attrs & PVF_REF)) {
@@ -3516,17 +4476,19 @@
 	/*
 	 * Keep the stats up to date
 	 */
-	if (opte == 0) {
+	if (opte == 0 && l2b) {
 		l2b->l2b_occupancy++;
 		pmap->pm_stats.resident_count++;
 	} 
 
+	PMAP_LOCK_L1(pmap);
+	pmap_fixup_l1_entry(pmap, va);
 
 	/*
 	 * If this is just a wiring change, the two PTEs will be
 	 * identical, so there's no need to update the page table.
 	 */
-	if (npte != opte) {
+	if (l2b && npte != opte && ((opte & L2_TYPE_MASK) != L2_TYPE_L)) {
 		boolean_t is_cached = pmap_is_current(pmap);
 
 		*ptep = npte;
@@ -3564,7 +4526,18 @@
 
 		if (m)
 			pmap_vac_me_harder(m, pmap, va);
+		if (m && ((va < VM_MAXUSER_ADDRESS ||
+		    m->object == kernel_object || 
+		    (m->object == kmem_object)) && m->reserv)) {
+			if (m->reserv->refcnt > 0 &&
+			    m->reserv->refcnt != SP_LARGE &&
+			    (m->reserv->refcnt % SP_SMALL) == 0)
+				pmap_promote_small(pmap, l2b, va);
+			else if (m->reserv->refcnt == SP_LARGE)
+				pmap_promote_large(pmap, va);
+		}
 	}
+	PMAP_UNLOCK_L1(pmap);
 }
 
 /*
@@ -3626,17 +4599,11 @@
 void
 pmap_change_wiring(pmap_t pmap, vm_offset_t va, boolean_t wired)
 {
-	struct l2_bucket *l2b;
-	pt_entry_t *ptep, pte;
 	vm_page_t pg;
 
 	vm_page_lock_queues();
  	PMAP_LOCK(pmap);
-	l2b = pmap_get_l2_bucket(pmap, va);
-	KASSERT(l2b, ("No l2b bucket in pmap_change_wiring"));
-	ptep = &l2b->l2b_kva[l2pte_index(va)];
-	pte = *ptep;
-	pg = PHYS_TO_VM_PAGE(l2pte_pa(pte));
+	pg = PHYS_TO_VM_PAGE(pmap_extract_locked(pmap, va));
 	if (pg) 
 		pmap_modify_pv(pg, pmap, va, PVF_WIRED, wired);
 	vm_page_unlock_queues();
@@ -3664,8 +4631,8 @@
  *		Extract the physical page address associated
  *		with the given map/virtual_address pair.
  */
-vm_paddr_t
-pmap_extract(pmap_t pm, vm_offset_t va)
+static vm_paddr_t
+pmap_extract_locked(pmap_t pm, vm_offset_t va)
 {
 	struct l2_dtable *l2;
 	pd_entry_t l1pd;
@@ -3674,15 +4641,13 @@
 	u_int l1idx;
 	l1idx = L1_IDX(va);
 
-	PMAP_LOCK(pm);
+	PMAP_LOCK_L1(pm);
+	pmap_fixup_l1_entry(pm, va);
 	l1pd = pm->pm_l1->l1_kva[l1idx];
-	if (l1pte_section_p(l1pd)) {
-		/*
-		 * These should only happen for pmap_kernel()
-		 */
-		KASSERT(pm == pmap_kernel(), ("huh"));
+	PMAP_UNLOCK_L1(pm);
+	if (l1pte_section_p(l1pd))
 		pa = (l1pd & L1_S_FRAME) | (va & L1_S_OFFSET);
-	} else {
+	else {
 		/*
 		 * Note that we can't rely on the validity of the L1
 		 * descriptor as an indication that a mapping exists.
@@ -3691,18 +4656,14 @@
 		l2 = pm->pm_l2[L2_IDX(l1idx)];
 
 		if (l2 == NULL ||
-		    (ptep = l2->l2_bucket[L2_BUCKET(l1idx)].l2b_kva) == NULL) {
-			PMAP_UNLOCK(pm);
+		    (ptep = l2->l2_bucket[L2_BUCKET(l1idx)].l2b_kva) == NULL)
 			return (0);
-		}
 
 		ptep = &ptep[l2pte_index(va)];
 		pte = *ptep;
 
-		if (pte == 0) {
-			PMAP_UNLOCK(pm);
+		if (pte == 0)
 			return (0);
-		}
 
 		switch (pte & L2_TYPE_MASK) {
 		case L2_TYPE_L:
@@ -3714,11 +4675,19 @@
 			break;
 		}
 	}
+	return (pa);
+}
 
+vm_paddr_t
+pmap_extract(pmap_t pm, vm_offset_t va)
+{
+	vm_paddr_t ret;
+
+	PMAP_LOCK(pm);
+	ret = pmap_extract_locked(pm, va);
 	PMAP_UNLOCK(pm);
-	return (pa);
+	return (ret);
 }
-
 /*
  * Atomically extract and hold the physical page with the given
  * pmap and virtual address pair if that mapping permits the given
@@ -3738,19 +4707,19 @@
 
 	vm_page_lock_queues();
  	PMAP_LOCK(pmap);
+	PMAP_LOCK_L1(pmap);
+	pmap_fixup_l1_entry(pmap, va);
 	l1pd = pmap->pm_l1->l1_kva[l1idx];
 	if (l1pte_section_p(l1pd)) {
-		/*
-		 * These should only happen for pmap_kernel()
-		 */
-		KASSERT(pmap == pmap_kernel(), ("huh"));
 		pa = (l1pd & L1_S_FRAME) | (va & L1_S_OFFSET);
 		if (l1pd & L1_S_PROT_W || (prot & VM_PROT_WRITE) == 0) {
 			m = PHYS_TO_VM_PAGE(pa);
 			vm_page_hold(m);
 		}
+		PMAP_UNLOCK_L1(pmap);
 			
 	} else {
+		PMAP_UNLOCK_L1(pmap);
 		/*
 		 * Note that we can't rely on the validity of the L1
 		 * descriptor as an indication that a mapping exists.
@@ -3814,8 +4783,8 @@
 	bzero(&pmap->pm_stats, sizeof pmap->pm_stats);
 	pmap->pm_stats.resident_count = 1;
 	if (vector_page < KERNBASE) {
-		pmap_enter(pmap, vector_page, PHYS_TO_VM_PAGE(systempage.pv_pa),
-		    VM_PROT_READ, 1);
+		pmap_enter(pmap, vector_page, 0, 
+		    PHYS_TO_VM_PAGE(systempage.pv_pa), VM_PROT_READ, 1);
 	} 
 }
 
@@ -3866,6 +4835,8 @@
 	vm_offset_t next_bucket;
 	pt_entry_t *ptep;
 	u_int cleanlist_idx, total, cnt;
+	vm_page_t m;
+	struct pv_entry *pve;
 	struct {
 		vm_offset_t va;
 		pt_entry_t *pte;
@@ -3894,12 +4865,48 @@
 		if (next_bucket > eva)
 			next_bucket = eva;
 
+		PMAP_LOCK_L1(pm);
+		pmap_fixup_l1_entry(pm, sva);
 		l2b = pmap_get_l2_bucket(pm, sva);
 		if (l2b == NULL) {
-			sva = next_bucket;
-			continue;
+			pd_entry_t *pd = &pm->pm_l1->l1_kva[L1_IDX(sva)];
+			if (l1pte_section_p(*pd)) {
+				struct l1_ttable *l1;
+				/* We can just remove the superpage. */
+				flushall = 1;
+				if ((sva == (sva & L1_S_ADDR_MASK)) &&
+				    (sva + L1_S_SIZE < eva)) {
+					m = PHYS_TO_VM_PAGE(*pd & L1_S_FRAME);
+					pve = pmap_find_pv(m, pm, sva);
+					if (pve) {
+						pmap_nuke_pv(m, pm, pve);
+						pmap_free_pv_entry(pve);
+					}
+					*pd = 0;
+					sva += L1_S_SIZE;
+					if (pm == pmap_kernel()) {
+						SLIST_FOREACH(l1, &l1_list,
+						    l1_link) {
+							l1->l1_kva[L1_IDX(sva)] =
+							    0;
+							PTE_SYNC(&l1->l1_kva[L1_IDX(sva)]);
+						}
+					}
+					PMAP_UNLOCK_L1(pm);
+					continue;
+				} else {
+					pmap_demote(pm, sva);
+					PMAP_UNLOCK_L1(pm);
+					l2b = pmap_get_l2_bucket(pm, sva);
+				}
+			} else {
+				PMAP_UNLOCK_L1(pm);
+				sva = next_bucket;
+				continue;
+			}
 		}
 
+		PMAP_UNLOCK_L1(pm);
 		ptep = &l2b->l2b_kva[l2pte_index(sva)];
 		mappings = 0;
 
@@ -3908,6 +4915,28 @@
 			pt_entry_t pte;
 			vm_paddr_t pa;
 
+			if ((*ptep & L2_TYPE_MASK) == L2_TYPE_L) {
+			/* 64KB superpage. */
+				if ((sva & L2_L_FRAME) == sva &&
+				    sva + L2_L_SIZE < eva) {
+					m = PHYS_TO_VM_PAGE(*ptep &
+					    L2_L_FRAME);
+					
+					pve = pmap_find_pv(m, pm, sva);
+					if (pve) {
+						pmap_nuke_pv(m, pm, pve);
+						pmap_free_pv_entry(pve);
+					}
+					for (int i = 0; i < 0x10; i++)
+						ptep[i] = 0;
+					sva += L2_L_SIZE;
+					ptep += 0x10;
+					flushall = 1;
+					mappings += 0x10;
+					continue;
+				}
+				pmap_demote(pm, sva);
+			}
 			pte = *ptep;
 
 			if (pte == 0) {
@@ -3929,15 +4958,13 @@
 			 * we could cluster a lot of these and do a
 			 * number of sequential pages in one go.
 			 */
-			if ((pg = PHYS_TO_VM_PAGE(pa)) != NULL) {
-				struct pv_entry *pve;
+			pg = PHYS_TO_VM_PAGE(pa);
 
-				pve = pmap_remove_pv(pg, pm, sva);
-				if (pve) {
-					is_exec = PV_BEEN_EXECD(pve->pv_flags);
-					is_refd = PV_BEEN_REFD(pve->pv_flags);
-					pmap_free_pv_entry(pve);
-				}
+			pve = pmap_remove_pv(pg, pm, sva);
+			if (pve) {
+				is_exec = PV_BEEN_EXECD(pve->pv_flags);
+				is_refd = PV_BEEN_REFD(pve->pv_flags);
+				pmap_free_pv_entry(pve);
 			}
 
 			if (!l2pte_valid(pte)) {
@@ -3958,8 +4985,7 @@
 			} else
 			if (cleanlist_idx == PMAP_REMOVE_CLEAN_LIST_SIZE) {
 				/* Nuke everything if needed. */
-				pmap_idcache_wbinv_all(pm);
-				pmap_tlb_flushID(pm);
+				flushall = 1;
 
 				/*
 				 * Roll back the previous PTE list,
@@ -3972,14 +4998,13 @@
 				*ptep = 0;
 				PTE_SYNC(ptep);
 				cleanlist_idx++;
-				flushall = 1;
 			} else {
 				*ptep = 0;
 				PTE_SYNC(ptep);
-					if (is_exec)
-						pmap_tlb_flushID_SE(pm, sva);
-					else
-					if (is_refd)
+				if (!flushall && is_exec)
+					pmap_tlb_flushID_SE(pm, sva);
+				else
+					if (!flushall && is_refd)
 						pmap_tlb_flushD_SE(pm, sva);
 			}
 
@@ -3996,15 +5021,17 @@
 			for (cnt = 0; cnt < cleanlist_idx; cnt++) {
 				vm_offset_t clva =
 				    cleanlist[cnt].va & ~1;
-				if (cleanlist[cnt].va & 1) {
-					pmap_idcache_wbinv_range(pm,
-					    clva, PAGE_SIZE);
-					pmap_tlb_flushID_SE(pm, clva);
-				} else {
-					pmap_dcache_wb_range(pm,
-					    clva, PAGE_SIZE, TRUE,
-					    FALSE);
-					pmap_tlb_flushD_SE(pm, clva);
+				if (!flushall) {
+					if (cleanlist[cnt].va & 1) {
+						pmap_idcache_wbinv_range(pm,
+						    clva, PAGE_SIZE);
+						pmap_tlb_flushID_SE(pm, clva);
+					} else {
+						pmap_dcache_wb_range(pm,
+						    clva, PAGE_SIZE, TRUE,
+						    FALSE);
+						pmap_tlb_flushD_SE(pm, clva);
+					}
 				}
 				*cleanlist[cnt].pte = 0;
 				PTE_SYNC_CURRENT(pm, cleanlist[cnt].pte);
@@ -4018,7 +5045,6 @@
 				 * easier to flush the whole cache.
 				 */
 				cleanlist_idx = PMAP_REMOVE_CLEAN_LIST_SIZE + 1;
-				pmap_idcache_wbinv_all(pm);
 				flushall = 1;
 			}
 		}
@@ -4026,9 +5052,11 @@
 		pmap_free_l2_bucket(pm, l2b, mappings);
 	}
 
+	if (flushall) {
+		pmap_idcache_wbinv_all(pm);
+		cpu_tlb_flushID();
+	}
 	vm_page_unlock_queues();
-	if (flushall)
-		cpu_tlb_flushID();
  	PMAP_UNLOCK(pm);
 }
 
@@ -4146,7 +5174,11 @@
 
 		l2b = pmap_get_l2_bucket(pmap_kernel(), va);
 
+		if (!l2b)
+			panic("fuck2");
 		sptep = ptep = &l2b->l2b_kva[l2pte_index(va)];
+		if ((*ptep & L2_TYPE_MASK) == L2_TYPE_L)
+			panic("bordel");
 
 		while (va < next_bucket) {
 			pte = *ptep;
@@ -4872,4 +5904,3 @@
 
 	return (NULL);
 }
-
---  arm/include/param.h.orig
+++  arm/include/param.h
@@ -90,6 +90,21 @@
 #define NBPDR		(1 << PDR_SHIFT)
 #define NPDEPG          (1 << (32 - PDR_SHIFT))
 
+/*
+ * SP_LEVELS is the number of superpage sizes.
+ */
+#define	SP_LEVELS	2
+
+/*
+ * SP_SMALL_SHIFT is LOG2("The Smallest Superpage Size" / PAGE_SIZE).
+ */
+#define	SP_SMALL_SHIFT	4
+
+/*
+ * XXX
+ */
+#define	SP_FACTOR_SHIFT	4
+
 #ifndef KSTACK_PAGES
 #define KSTACK_PAGES    2
 #endif /* !KSTACK_PAGES */
---  arm/include/pmap.h.orig
+++  arm/include/pmap.h
@@ -136,7 +136,6 @@
  */
 #define	L2_LOG2		((32 - L1_S_SHIFT) - L2_BUCKET_LOG2)
 #define	L2_SIZE		(1 << L2_LOG2)
-
 struct	pmap {
 	struct mtx		pm_mtx;
 	u_int8_t		pm_domain;
@@ -146,6 +145,7 @@
 	int			pm_count;	/* reference count */
 	int			pm_active;	/* active on cpus */
 	struct pmap_statistics	pm_stats;	/* pmap statictics */
+	struct pv_entry		*pm_firstpv;	/* First pv not a section map */
 	TAILQ_HEAD(,pv_entry)	pm_pvlist;	/* list of mappings in pmap */
 };
 
@@ -178,6 +178,7 @@
 	TAILQ_ENTRY(pv_entry)   pv_list;
 	TAILQ_ENTRY(pv_entry)	pv_plist;
 	int		pv_flags;	/* flags (wired, etc...) */
+	vm_page_t	pv_page;	/* ASsociated bage. */
 } *pv_entry_t;
 
 #define PV_ENTRY_NULL   ((pv_entry_t) 0)
@@ -266,6 +267,7 @@
 #define	L1_S_CACHE_MASK_generic	(L1_S_B|L1_S_C)
 #define	L1_S_CACHE_MASK_xscale	(L1_S_B|L1_S_C|L1_S_XSCALE_TEX(TEX_XSCALE_X))
 
+
 #define	L2_L_PROT_U		(L2_AP(AP_U))
 #define	L2_L_PROT_W		(L2_AP(AP_W))
 #define	L2_L_PROT_MASK		(L2_L_PROT_U|L2_L_PROT_W)
@@ -494,6 +496,9 @@
 #define	PVF_EXEC	0x10		/* mapping is executable */
 #define	PVF_UNC		0x20		/* mapping is 'user' non-cacheable */
 #define	PVF_KNC		0x40		/* mapping is 'kernel' non-cacheable */
+#define PVF_DEMOTED	0x80		/* Page was demoted. */
+#define PVF_SECTION	0x100		/* Page is a section mapping. */
+#define PVF_LARGE	0x200		/* Page is a large page. */
 #define	PVF_NC		(PVF_UNC|PVF_KNC)
 
 void vector_page_setprot(int);
@@ -544,6 +549,7 @@
 void arm_unmap_nocache(void *, vm_size_t);
 
 extern vm_paddr_t dump_avail[];
+
 #endif	/* _KERNEL */
 
 #endif	/* !LOCORE */
---  arm/include/vmparam.h.orig
+++  arm/include/vmparam.h
@@ -67,6 +67,7 @@
 #define	VM_NFREEPOOL		2
 #define	VM_FREEPOOL_DEFAULT	0
 #define	VM_FREEPOOL_DIRECT	1
+#define	VM_FREEPOOL_RESERV	0
 
 /*
  * we support 2 free lists:
@@ -131,4 +132,8 @@
 #ifdef ARM_USE_SMALL_ALLOC
 #define UMA_MD_SMALL_ALLOC
 #endif /* ARM_USE_SMALL_ALLOC */
+
+#ifndef VM_IMAGE_BASE
+#define VM_IMAGE_BASE	0x8000
+#endif /* VM_IMAGE_BASE */
 #endif	/* _MACHINE_VMPARAM_H_ */
---  conf/files.orig
+++  conf/files
@@ -2079,6 +2079,7 @@
 vm/vm_pageq.c			standard
 vm/vm_pager.c			standard
 vm/vm_phys.c			standard
+vm/vm_reserv.c			standard
 vm/vm_unix.c			standard
 vm/vm_zeroidle.c		standard
 vm/vnode_pager.c		standard
---  conf/options.orig
+++  conf/options
@@ -549,6 +549,9 @@
 VFS_BIO_DEBUG		opt_global.h
 
 # These are VM related options
+SP_LEVELS		opt_vm.h
+SP_SMALL_SHIFT		opt_vm.h
+SP_FACTOR_SHIFT		opt_vm.h
 VM_KMEM_SIZE		opt_vm.h
 VM_KMEM_SIZE_SCALE	opt_vm.h
 VM_KMEM_SIZE_MAX	opt_vm.h
